t / lib-git-svn.shon commit Reduce the number of connects when fetching (ba22785)
   1. ./test-lib.sh
   2
   3if test -n "$NO_SVN_TESTS"
   4then
   5        test_expect_success 'skipping git-svn tests, NO_SVN_TESTS defined' :
   6        test_done
   7        exit
   8fi
   9
  10GIT_DIR=$PWD/.git
  11GIT_SVN_DIR=$GIT_DIR/svn/git-svn
  12SVN_TREE=$GIT_SVN_DIR/svn-tree
  13
  14svn >/dev/null 2>&1
  15if test $? -ne 1
  16then
  17    test_expect_success 'skipping git-svn tests, svn not found' :
  18    test_done
  19    exit
  20fi
  21
  22svnrepo=$PWD/svnrepo
  23
  24perl -w -e "
  25use SVN::Core;
  26use SVN::Repos;
  27\$SVN::Core::VERSION gt '1.1.0' or exit(42);
  28system(qw/svnadmin create --fs-type fsfs/, '$svnrepo') == 0 or exit(41);
  29" >&3 2>&4
  30x=$?
  31if test $x -ne 0
  32then
  33        if test $x -eq 42; then
  34                err='Perl SVN libraries must be >= 1.1.0'
  35        elif test $x -eq 41; then
  36                err='svnadmin failed to create fsfs repository'
  37        else
  38                err='Perl SVN libraries not found or unusable, skipping test'
  39        fi
  40        test_expect_success "$err" :
  41        test_done
  42        exit
  43fi
  44
  45rawsvnrepo="$svnrepo"
  46svnrepo="file://$svnrepo"
  47
  48poke() {
  49        test-chmtime +1 "$1"
  50}
  51
  52SVN_HTTPD_MODULE_PATH=${SVN_HTTPD_MODULE_PATH-'/usr/lib/apache2/modules'}
  53SVN_HTTPD_PATH=${SVN_HTTPD_PATH-'/usr/sbin/apache2'}
  54
  55start_httpd () {
  56        if test -z "$SVN_HTTPD_PORT"
  57        then
  58                echo >&2 'SVN_HTTPD_PORT is not defined!'
  59                return
  60        fi
  61
  62        mkdir "$GIT_DIR"/logs
  63
  64        cat > "$GIT_DIR/httpd.conf" <<EOF
  65ServerName "git-svn test"
  66ServerRoot "$GIT_DIR"
  67DocumentRoot "$GIT_DIR"
  68PidFile "$GIT_DIR/httpd.pid"
  69Listen 127.0.0.1:$SVN_HTTPD_PORT
  70LoadModule dav_module $SVN_HTTPD_MODULE_PATH/mod_dav.so
  71LoadModule dav_svn_module $SVN_HTTPD_MODULE_PATH/mod_dav_svn.so
  72<Location /svn>
  73        DAV svn
  74        SVNPath $rawsvnrepo
  75</Location>
  76EOF
  77        "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k start
  78        svnrepo=http://127.0.0.1:$SVN_HTTPD_PORT/svn
  79}
  80
  81stop_httpd () {
  82        test -z "$SVN_HTTPD_PORT" && return
  83        "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k stop
  84}
  85
  86convert_to_rev_db () {
  87        perl -w -- - "$@" <<\EOF
  88use strict;
  89@ARGV == 2 or die "Usage: convert_to_rev_db <input> <output>";
  90open my $wr, '+>', $ARGV[1] or die "$!: couldn't open: $ARGV[1]";
  91open my $rd, '<', $ARGV[0] or die "$!: couldn't open: $ARGV[0]";
  92my $size = (stat($rd))[7];
  93($size % 24) == 0 or die "Inconsistent size: $size";
  94while (sysread($rd, my $buf, 24) == 24) {
  95        my ($r, $c) = unpack('NH40', $buf);
  96        my $offset = $r * 41;
  97        seek $wr, 0, 2 or die $!;
  98        my $pos = tell $wr;
  99        if ($pos < $offset) {
 100                for (1 .. (($offset - $pos) / 41)) {
 101                        print $wr (('0' x 40),"\n") or die $!;
 102                }
 103        }
 104        seek $wr, $offset, 0 or die $!;
 105        print $wr $c,"\n" or die $!;
 106}
 107close $wr or die $!;
 108close $rd or die $!;
 109EOF
 110}